require 'spec_helper'

describe Speedflow::Plugin::Git::Client do
  let(:client) do
    client = ::Speedflow::Plugin::Git::Client.new(double, double)
    client.git_client = double
    client
  end

  it '.create_branch' do
    allow(client.git_client)
      .to receive_message_chain(:open, :branch, :checkout)

    client.create_branch('test', 'origin/master')
  end

  it '.branches' do
    allow(client.git_client)
      .to receive_message_chain(:open, :branches, :send)

    client.branches
  end

  it '.safe' do
    allow(client.prompt)
      .to receive(:error)
      .with('Git errors')
    allow(client.prompt)
      .to receive(:errors)
    e = expect do
      client.safe do
        raise StandardError.new('Error'), '...'
      end
    end
    e.to raise_error(SystemExit)
  end
end
